// SORCERIAN (for PC-88/PC-98/PC-88VA/X1turbo) t@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>

#include "d88.h"

static unsigned char dir[0x400*5];				// Directory (1024byte x 5sector) (Max)
static unsigned char buff[0x200*9*160];			// 512byte x 9sector x 160track (Max)
static unsigned char id[4*16];					// 4byte x Max16sector
char fname[FILENAME_MAX];						// ؂ot@C
static char dirpath[FILENAME_MAX];				// 쐬fBNg

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[]) {
	int i,c,fn;
	int s_trk,s_sec,e_trk,e_sec,entsize,locsize,size;
	int mode=1;

	if (argc < 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] [-d]\n",argv[0]);
		return 1;
	}
	if (argc > 2) {
		if (!strcmp(argv[2],"-d")) mode=0;
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W

	for (int d=0; d<numdisk; d++) {		// C[W̏
		if (mode) {
			sprintf(dirpath,"%03d",d);	// TufBNg̐
			_mkdir(dirpath);
			_chdir(dirpath);
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}
		else printf("\n[%s]\n",disk.GetDiskName());

		disk.SelectDisk(d);

		int maxsec, N, secsize, trksize;
		// fBXN߂
		maxsec = disk.ReadID(1, id, sizeof(id))/4;	// ZN^(ő16)
		// veNgZN^΍
		if (id[2] == 0xf7 && id[3] == 0x00) maxsec--;
		N = id[3+4];		// ZN^(擪ɃveNgZN^ꍇ邽߁A2Ԃ߂̃ZN^̒l̗p)
		secsize = 1<<(N+7);
		trksize = secsize*maxsec;
		printf("N=%d, Sec/Trk = %d, secsize = 0x%04x, trksize = 0x%04x\n",N, maxsec, secsize, trksize);

		disk.SetRecordRange(0x01,maxsec);
		// fBNg̓ǂݍ
		memset(dir, 0xff, sizeof(dir));
		disk.ReadDATA(0x01, 0x00, 0x01, 0x01, N, dir, trksize);

		if (!memcmp(dir, "     ", 5)) {			// PC88vOfBXN
			fcut("BIOS",  0x02, 0x01, 0x00, 0x01, 0x01, 0x0000, 0x2000);
			fcut("SEDAT", 0x03, 0x01, 0x01, 0x01, 0x01, 0x0000, 0x1000);
			fcut("SS000", 0x03, 0x01, 0x01, 0x09, 0x01, 0x0000, 0x0500);
		}

		if (disk.GetDiskType()==disk.TYPE_2DD &&
			!memcmp(&dir[0x00], "BIOS",  4) &&
			!memcmp(&dir[0x10], "BIOS2", 5) &&
			!memcmp(&dir[0x20], "BIOS3", 5) ) {	// PC98vOfBXN

			fcut("SS039", 0x0a, 0x05, 0x00, 0x09, 0x01, 0x0000, 0x0430);
		}

		for (fn=0; fn<(sizeof(dir)/0x10); fn++) {
			const unsigned char *ent = &dir[fn*0x10];
			if (*ent == 0x20) continue;		// PC88vOfBXN
			if (*(ent+7) == 'K') continue;	// 폜t@C
			if (*ent == 0xff) break;		// fBNg̍Ō

			int i;
			int fnp = 0;
			memset(fname, 0x00, sizeof(fname));
			for (i = 0x00; i < 0x06; i++) {
				char c = ent[i];				// t@CPo
				if (c=='\0') break;
				fname[fnp++] = c;				// t@C\
			}
			fname[fnp++] = '\0';				// ̍Ō

			s_trk = *(ent+0x0c);							// JngbN
			s_sec = *(ent+0x0d);							// JnZN^
			e_trk = *(ent+0x0e);							// IgbN
			e_sec = *(ent+0x0f);							// IZN^
			entsize = *(ent+0x0a)+*(ent+0x0b)*0x100+1;		// L^̃t@CTCY
			locsize = ( (e_trk*maxsec+e_sec-1) - (s_trk*maxsec+s_sec-1) +1) * secsize;	// ۂɎgpĂTCY

			// ۂɎgpĂTCYƋL^̃t@CTCYقȂꍇ́AKp
			size = entsize;
			if (entsize > locsize) size=locsize;

//			printf("%-6s   START:%02x %02x    END:%02x %02x   SIZE:%04x\n",fname,s_trk,s_sec,e_trk,e_sec,size);
			printf("%-6s   START:%02x %02x    END:%02x %02x   ENTRYSIZE:%4x   SIZE:%4x\n",fname,s_trk,s_sec,e_trk,e_sec,entsize,size);
			fcut(fname, s_trk, s_trk>>1, s_trk&1, s_sec, N, 0x0000, size);
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}
